OGRE: Ogre::Technique Class Reference - OGRE Documentation

Classes | Public Types | Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes

# Ogre::Technique Class Reference
[Materials]

Class representing an approach to rendering this particular Material. More...

`#include <OgreTechnique.h>`

Inheritance diagram for Ogre::Technique:
[legend]

List of all members.

## Classes
struct | GPUDeviceNameRule
| Rule controlling whether technique is deemed supported based on GPU device name. More...
struct | GPUVendorRule
| Rule controlling whether technique is deemed supported based on GPU vendor. More...
## Public Types
enum | IncludeOrExclude { INCLUDE = 0, EXCLUDE = 1 }
| Directive used to manually control technique support based on the inclusion or exclusion of some factor. More...
typedef vector< GPUVendorRule > ::type | GPUVendorRuleList
typedef vector < GPUDeviceNameRule >::type | GPUDeviceNameRuleList
typedef VectorIterator< Passes > | PassIterator
typedef VectorIterator < IlluminationPassList > | IlluminationPassIterator
typedef ConstVectorIterator < GPUVendorRuleList > | GPUVendorRuleIterator
typedef ConstVectorIterator < GPUDeviceNameRuleList > | GPUDeviceNameRuleIterator
## Public Member Functions
| Technique (Material *parent)
| Constructor.
| Technique (Material *parent, const Technique &oth)
| Copy constructor.
| ~Technique ()
bool | isSupported (void) const
| Indicates if this technique is supported by the current graphics card.
String | _compile (bool autoManageTextureUnits)
| Internal compilation method; see Material::compile.
bool | checkGPURules (StringUtil::StrStreamType &errors)
| Internal method for checking GPU vendor / device rules.
bool | checkHardwareSupport (bool autoManageTextureUnits, StringUtil::StrStreamType &compileErrors)
| Internal method for checking hardware support.
void | _compileIlluminationPasses (void)
| Internal method for splitting the passes into illumination passes.
Pass * | createPass (void)
| Creates a new Pass for this Technique.
Pass * | getPass (unsigned short index)
| Retrieves the Pass with the given index.
Pass * | getPass (const String &name)
| Retrieves the Pass matching name.
unsigned short | getNumPasses (void) const
| Retrieves the number of passes.
void | removePass (unsigned short index)
| Removes the Pass with the given index.
void | removeAllPasses (void)
| Removes all Passes from this Technique.
bool | movePass (const unsigned short sourceIndex, const unsigned short destinationIndex)
| Move a pass from source index to destination index.
const PassIterator | getPassIterator (void)
| Gets an iterator over the passes in this Technique.
const IlluminationPassIterator | getIlluminationPassIterator (void)
| Gets an iterator over the illumination-stage categorised passes.
Material * | getParent (void) const
| Gets the parent Material.
Technique & | operator= (const Technique &rhs)
| Overloaded operator to copy on Technique to another.
const String & | getResourceGroup (void) const
| Gets the resource group of the ultimate parent Material.
bool | isTransparent (void) const
| Returns true if this Technique involves transparency.
bool | isTransparentSortingEnabled (void) const
| Returns true if this Technique has transparent sorting enabled.
bool | isTransparentSortingForced (void) const
| Returns true if this Technique has transparent sorting forced.
void | _prepare (void)
| Internal prepare method, derived from call to Material::prepare.
void | _unprepare (void)
| Internal unprepare method, derived from call to Material::unprepare.
void | _load (void)
| Internal load method, derived from call to Material::load.
void | _unload (void)
| Internal unload method, derived from call to Material::unload.
bool | isLoaded (void) const
void | _notifyNeedsRecompile (void)
| Tells the technique that it needs recompilation.
Ogre::MaterialPtr | getShadowCasterMaterial () const
| return this material specific shadow casting specific material
void | setShadowCasterMaterial (Ogre::MaterialPtr val)
| set this material specific shadow casting specific material
void | setShadowCasterMaterial (const Ogre::String &name)
| set this material specific shadow casting specific material
Ogre::MaterialPtr | getShadowReceiverMaterial () const
| return this material specific shadow receiving specific material
void | setShadowReceiverMaterial (Ogre::MaterialPtr val)
| set this material specific shadow receiving specific material
void | setShadowReceiverMaterial (const Ogre::String &name)
| set this material specific shadow receiving specific material
void | setPointSize (Real ps)
| Sets the point size properties for every Pass in this Technique.
void | setAmbient (Real red, Real green, Real blue)
| Sets the ambient colour reflectance properties for every Pass in every Technique.
void | setAmbient (const ColourValue &ambient)
| Sets the ambient colour reflectance properties for every Pass in every Technique.
void | setDiffuse (Real red, Real green, Real blue, Real alpha)
| Sets the diffuse colour reflectance properties of every Pass in every Technique.
void | setDiffuse (const ColourValue &diffuse)
| Sets the diffuse colour reflectance properties of every Pass in every Technique.
void | setSpecular (Real red, Real green, Real blue, Real alpha)
| Sets the specular colour reflectance properties of every Pass in every Technique.
void | setSpecular (const ColourValue &specular)
| Sets the specular colour reflectance properties of every Pass in every Technique.
void | setShininess (Real val)
| Sets the shininess properties of every Pass in every Technique.
void | setSelfIllumination (Real red, Real green, Real blue)
| Sets the amount of self-illumination of every Pass in every Technique.
void | setSelfIllumination (const ColourValue &selfIllum)
| Sets the amount of self-illumination of every Pass in every Technique.
void | setDepthCheckEnabled (bool enabled)
| Sets whether or not each Pass renders with depth-buffer checking on or not.
void | setDepthWriteEnabled (bool enabled)
| Sets whether or not each Pass renders with depth-buffer writing on or not.
void | setDepthFunction (CompareFunction func)
| Sets the function used to compare depth values when depth checking is on.
void | setColourWriteEnabled (bool enabled)
| Sets whether or not colour buffer writing is enabled for each Pass.
void | setCullingMode (CullingMode mode)
| Sets the culling mode for each pass based on the 'vertex winding'.
void | setManualCullingMode (ManualCullingMode mode)
| Sets the manual culling mode, performed by CPU rather than hardware.
void | setLightingEnabled (bool enabled)
| Sets whether or not dynamic lighting is enabled for every Pass.
void | setShadingMode (ShadeOptions mode)
| Sets the type of light shading required.
void | setFog (bool overrideScene, FogMode mode=FOG_NONE, const ColourValue &colour=ColourValue::White, Real expDensity=0.001, Real linearStart=0.0, Real linearEnd=1.0)
| Sets the fogging mode applied to each pass.
void | setDepthBias (float constantBias, float slopeScaleBias)
| Sets the depth bias to be used for each Pass.
void | setTextureFiltering (TextureFilterOptions filterType)
| Set texture filtering for every texture unit in every Pass.
void | setTextureAnisotropy (unsigned int maxAniso)
| Sets the anisotropy level to be used for all textures.
void | setSceneBlending (const SceneBlendType sbt)
| Sets the kind of blending every pass has with the existing contents of the scene.
void | setSeparateSceneBlending (const SceneBlendType sbt, const SceneBlendType sbta)
| Sets the kind of blending every pass has with the existing contents of the scene, using individual factors both color and alpha channels.
void | setSceneBlending (const SceneBlendFactor sourceFactor, const SceneBlendFactor destFactor)
| Allows very fine control of blending every Pass with the existing contents of the scene.
void | setSeparateSceneBlending (const SceneBlendFactor sourceFactor, const SceneBlendFactor destFactor, const SceneBlendFactor sourceFactorAlpha, const SceneBlendFactor destFactorAlpha)
| Allows very fine control of blending every Pass with the existing contents of the scene, using individual factors both color and alpha channels.
void | setLodIndex (unsigned short index)
| Assigns a level-of-detail (LOD) index to this Technique.
unsigned short | getLodIndex (void) const
| Gets the level-of-detail index assigned to this Technique.
void | setSchemeName (const String &schemeName)
| Set the 'scheme name' for this technique.
const String & | getSchemeName (void) const
| Returns the scheme to which this technique is assigned.
unsigned short | _getSchemeIndex (void) const
| Internal method for getting the scheme index.
bool | isDepthWriteEnabled (void) const
| Is depth writing going to occur on this technique?
bool | isDepthCheckEnabled (void) const
| Is depth checking going to occur on this technique?
bool | hasColourWriteDisabled (void) const
| Exists colour writing disabled pass on this technique?
void | setName (const String &name)
| Set the name of the technique.
const String & | getName (void) const
| Gets the name of the technique.
bool | applyTextureAliases (const AliasTextureNamePairList &aliasList, const bool apply=true) const
| Applies texture names to Texture Unit State with matching texture name aliases.
void | addGPUVendorRule (GPUVendor vendor, IncludeOrExclude includeOrExclude)
| Add a rule which manually influences the support for this technique based on a GPU vendor.
void | addGPUVendorRule (const GPUVendorRule &rule)
| Add a rule which manually influences the support for this technique based on a GPU vendor.
void | removeGPUVendorRule (GPUVendor vendor)
| Removes a matching vendor rule.
GPUVendorRuleIterator | getGPUVendorRuleIterator () const
| Get an iterator over the currently registered vendor rules.
void | addGPUDeviceNameRule (const String &devicePattern, IncludeOrExclude includeOrExclude, bool caseSensitive=false)
| Add a rule which manually influences the support for this technique based on a pattern that matches a GPU device name (e.g.
void | addGPUDeviceNameRule (const GPUDeviceNameRule &rule)
| Add a rule which manually influences the support for this technique based on a pattern that matches a GPU device name (e.g.
void | removeGPUDeviceNameRule (const String &devicePattern)
| Removes a matching device name rule.
GPUDeviceNameRuleIterator | getGPUDeviceNameRuleIterator () const
| Get an iterator over the currently registered device name rules.
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Protected Types
enum | IlluminationPassesState { IPS_COMPILE_DISABLED = -1, IPS_NOT_COMPILED = 0, IPS_COMPILED = 1 }
typedef vector< Pass * >::type | Passes
## Protected Member Functions
void | clearIlluminationPasses (void)
| Internal method for clearing illumination pass list.
bool | checkManuallyOrganisedIlluminationPasses ()
| Internal method - check for manually assigned illumination passes.
## Protected Attributes
Passes | mPasses
| List of primary passes.
IlluminationPassList | mIlluminationPasses
| List of derived passes, categorised into IlluminationStage (ordered).
Material * | mParent
bool | mIsSupported
IlluminationPassesState | mIlluminationPassesCompilationPhase
unsigned short | mLodIndex
| LOD level.
unsigned short | mSchemeIndex
| Scheme index, derived from scheme name but the names are held on MaterialManager, for speed an index is used here.
String | mName
MaterialPtr | mShadowCasterMaterial
| When casting shadow, if not using default Ogre shadow casting material, or nor using fixed function casting, mShadowCasterMaterial let you customize per material shadow caster behavior.
String | mShadowCasterMaterialName
| When casting shadow, if not using default Ogre shadow casting material, or nor using fixed function casting, mShadowCasterMaterial let you customize per material shadow caster behavior.There only material name is stored so that it can be loaded once all file parsed in a resource group.
MaterialPtr | mShadowReceiverMaterial
| When receiving shadow, if not using default Ogre shadow receiving material, or nor using fixed function texture projection receiving, mShadowReceiverMaterial let you customize per material shadow caster behavior.
String | mShadowReceiverMaterialName
| When receiving shadow, if not using default Ogre shadow receiving material, or nor using fixed function texture projection receiving, mShadowReceiverMaterial let you customize per material shadow caster behavior.
UserObjectBindings | mUserObjectBindings
GPUVendorRuleList | mGPUVendorRules
GPUDeviceNameRuleList | mGPUDeviceNameRules

## Detailed Description

Class representing an approach to rendering this particular Material.

Remarks:
  Ogre will attempt to use the best technique supported by the active hardware, unless you specifically request a lower detail technique (say for distant rendering).

Definition at line 53 of file OgreTechnique.h.

## Member Typedef Documentation

typedef ConstVectorIterator<GPUDeviceNameRuleList> Ogre::Technique::GPUDeviceNameRuleIterator

Definition at line 692 of file OgreTechnique.h.

typedef vector<GPUDeviceNameRule>::type Ogre::Technique::GPUDeviceNameRuleList

Definition at line 143 of file OgreTechnique.h.

typedef ConstVectorIterator<GPUVendorRuleList> Ogre::Technique::GPUVendorRuleIterator

Definition at line 651 of file OgreTechnique.h.

typedef vector<GPUVendorRule>::type Ogre::Technique::GPUVendorRuleList

Definition at line 142 of file OgreTechnique.h.

typedef VectorIterator<IlluminationPassList> Ogre::Technique::IlluminationPassIterator

Definition at line 201 of file OgreTechnique.h.

typedef vector<Pass*>::type Ogre::Technique::Passes`[protected]`

Definition at line 64 of file OgreTechnique.h.

typedef VectorIterator<Passes> Ogre::Technique::PassIterator

Definition at line 198 of file OgreTechnique.h.

## Member Enumeration Documentation

enum Ogre::Technique::IlluminationPassesState`[protected]`

Enumerator:

  IPS_COMPILE_DISABLED |
  IPS_NOT_COMPILED |
  IPS_COMPILED |

Definition at line 57 of file OgreTechnique.h.

enum Ogre::Technique::IncludeOrExclude

Directive used to manually control technique support based on the inclusion or exclusion of some factor.

Enumerator:

  INCLUDE | Inclusive - only support if present.
  EXCLUDE | Exclusive - do not support if present.

Definition at line 114 of file OgreTechnique.h.

## Constructor & Destructor Documentation

Ogre::Technique::Technique | ( | Material * | parent | ) |

Constructor.

Ogre::Technique::Technique | ( | Material * | parent,
|  | const Technique & | oth |
| ) |  |  |

Copy constructor.

Ogre::Technique::~Technique | ( |  | ) |

## Member Function Documentation

String Ogre::Technique::_compile | ( | bool | autoManageTextureUnits | ) |

Internal compilation method; see Material::compile.

Returns:
  Any information explaining problems with the compile.

void Ogre::Technique::_compileIlluminationPasses | ( | void |  | ) |

Internal method for splitting the passes into illumination passes.

unsigned short Ogre::Technique::_getSchemeIndex | ( | void |  | ) | const

Internal method for getting the scheme index.

void Ogre::Technique::_load | ( | void |  | ) |

Internal load method, derived from call to Material::load.

void Ogre::Technique::_notifyNeedsRecompile | ( | void |  | ) |

Tells the technique that it needs recompilation.

void Ogre::Technique::_prepare | ( | void |  | ) |

Internal prepare method, derived from call to Material::prepare.

void Ogre::Technique::_unload | ( | void |  | ) |

Internal unload method, derived from call to Material::unload.

void Ogre::Technique::_unprepare | ( | void |  | ) |

Internal unprepare method, derived from call to Material::unprepare.

void Ogre::Technique::addGPUDeviceNameRule | ( | const String & | devicePattern,
|  | IncludeOrExclude | includeOrExclude,
|  | bool | caseSensitive = `false` |
| ) |  |  |

Add a rule which manually influences the support for this technique based on a pattern that matches a GPU device name (e.g.

'*8800*').

Remarks:
  You can use this facility to manually control whether a technique is considered supported, based on a GPU device name pattern. You can add inclusive or exclusive rules, and you can add as many of each as you like. If at least one inclusive rule is added, a technique is considered unsupported if it does not match any of those inclusive rules. If exclusive rules are added, the technique is considered unsupported if it matches any of those inclusive rules. The pattern you supply can include wildcard characters ('*') if you only want to match part of the device name.

Note:
  Any rule for the same device pattern will be removed before adding this one.

Parameters:

  | devicePattern | The GPU vendor
  | includeOrExclude | Whether this is an inclusive or exclusive rule
  | caseSensitive | Whether the match is case sensitive or not

void Ogre::Technique::addGPUDeviceNameRule | ( | const GPUDeviceNameRule & | rule | ) |

Add a rule which manually influences the support for this technique based on a pattern that matches a GPU device name (e.g.

'*8800*').

Remarks:
  You can use this facility to manually control whether a technique is considered supported, based on a GPU device name pattern. You can add inclusive or exclusive rules, and you can add as many of each as you like. If at least one inclusive rule is added, a technique is considered unsupported if it does not match any of those inclusive rules. If exclusive rules are added, the technique is considered unsupported if it matches any of those inclusive rules. The pattern you supply can include wildcard characters ('*') if you only want to match part of the device name.

Note:
  Any rule for the same device pattern will be removed before adding this one.

void Ogre::Technique::addGPUVendorRule | ( | const GPUVendorRule & | rule | ) |

Add a rule which manually influences the support for this technique based on a GPU vendor.

Remarks:
  You can use this facility to manually control whether a technique is considered supported, based on a GPU vendor. You can add inclusive or exclusive rules, and you can add as many of each as you like. If at least one inclusive rule is added, a technique is considered unsupported if it does not match any of those inclusive rules. If exclusive rules are added, the technique is considered unsupported if it matches any of those inclusive rules.

Note:
  Any rule for the same vendor will be removed before adding this one.

void Ogre::Technique::addGPUVendorRule | ( | GPUVendor | vendor,
|  | IncludeOrExclude | includeOrExclude |
| ) |  |  |

Add a rule which manually influences the support for this technique based on a GPU vendor.

Remarks:
  You can use this facility to manually control whether a technique is considered supported, based on a GPU vendor. You can add inclusive or exclusive rules, and you can add as many of each as you like. If at least one inclusive rule is added, a technique is considered unsupported if it does not match any of those inclusive rules. If exclusive rules are added, the technique is considered unsupported if it matches any of those inclusive rules.

Note:
  Any rule for the same vendor will be removed before adding this one.

Parameters:

  | vendor | The GPU vendor
  | includeOrExclude | Whether this is an inclusive or exclusive rule

bool Ogre::Technique::applyTextureAliases | ( | const AliasTextureNamePairList & | aliasList,
|  | const bool | apply = `true` |
| ) |  |  | const

Applies texture names to Texture Unit State with matching texture name aliases.

All passes, and Texture Unit States within the technique are checked. If matching texture aliases are found then true is returned.

Parameters:

  | aliasList | is a map container of texture alias, texture name pairs
  | apply | set true to apply the texture aliases else just test to see if texture alias matches are found.

Returns:
  True if matching texture aliases were found in the Technique.

bool Ogre::Technique::checkGPURules | ( | StringUtil::StrStreamType & | errors | ) |

Internal method for checking GPU vendor / device rules.

bool Ogre::Technique::checkHardwareSupport | ( | bool | autoManageTextureUnits,
|  | StringUtil::StrStreamType & | compileErrors |
| ) |  |  |

Internal method for checking hardware support.

bool Ogre::Technique::checkManuallyOrganisedIlluminationPasses | ( |  | ) | `[protected]`

Internal method - check for manually assigned illumination passes.

void Ogre::Technique::clearIlluminationPasses | ( | void |  | ) | `[protected]`

Internal method for clearing illumination pass list.

Pass* Ogre::Technique::createPass | ( | void |  | ) |

Creates a new Pass for this Technique.

Remarks:
  A Pass is a single rendering pass, i.e. a single draw of the given material. Note that if you create a pass without a fragment program, during compilation of the material the pass may be split into multiple passes if the graphics card cannot handle the number of texture units requested. For passes with fragment programs, however, the number of passes you create will never be altered, so you have to make sure that you create an alternative fallback Technique for if a card does not have enough facilities for what you're asking for.

GPUDeviceNameRuleIterator Ogre::Technique::getGPUDeviceNameRuleIterator | ( |  | ) | const

Get an iterator over the currently registered device name rules.

GPUVendorRuleIterator Ogre::Technique::getGPUVendorRuleIterator | ( |  | ) | const

Get an iterator over the currently registered vendor rules.

const IlluminationPassIterator Ogre::Technique::getIlluminationPassIterator | ( | void |  | ) |

Gets an iterator over the illumination-stage categorised passes.

unsigned short Ogre::Technique::getLodIndex | ( | void |  | ) | const

Gets the level-of-detail index assigned to this Technique.

Definition at line 557 of file OgreTechnique.h.

const String& Ogre::Technique::getName | ( | void |  | ) | const

Gets the name of the technique.

Definition at line 601 of file OgreTechnique.h.

unsigned short Ogre::Technique::getNumPasses | ( | void |  | ) | const

Retrieves the number of passes.

Material* Ogre::Technique::getParent | ( | void |  | ) | const

Gets the parent Material.

Definition at line 205 of file OgreTechnique.h.

Pass* Ogre::Technique::getPass | ( | unsigned short | index | ) |

Retrieves the Pass with the given index.

Pass* Ogre::Technique::getPass | ( | const String & | name | ) |

Retrieves the Pass matching name.

Returns 0 if name match is not found.

const PassIterator Ogre::Technique::getPassIterator | ( | void |  | ) |

Gets an iterator over the passes in this Technique.

const String& Ogre::Technique::getResourceGroup | ( | void |  | ) | const

Gets the resource group of the ultimate parent Material.

const String& Ogre::Technique::getSchemeName | ( | void |  | ) | const

Returns the scheme to which this technique is assigned.

See also:
  Technique::setSchemeName

Ogre::MaterialPtr Ogre::Technique::getShadowCasterMaterial | ( |  | ) | const

return this material specific shadow casting specific material

Ogre::MaterialPtr Ogre::Technique::getShadowReceiverMaterial | ( |  | ) | const

return this material specific shadow receiving specific material

UserObjectBindings& Ogre::Technique::getUserObjectBindings | ( |  | ) |

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also:
  UserObjectBindings::setUserAny.

Definition at line 700 of file OgreTechnique.h.

const UserObjectBindings& Ogre::Technique::getUserObjectBindings | ( |  | ) | const

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also:
  UserObjectBindings::setUserAny.

Definition at line 706 of file OgreTechnique.h.

bool Ogre::Technique::hasColourWriteDisabled | ( | void |  | ) | const

Exists colour writing disabled pass on this technique?

bool Ogre::Technique::isDepthCheckEnabled | ( | void |  | ) | const

Is depth checking going to occur on this technique?

bool Ogre::Technique::isDepthWriteEnabled | ( | void |  | ) | const

Is depth writing going to occur on this technique?

bool Ogre::Technique::isLoaded | ( | void |  | ) | const

bool Ogre::Technique::isSupported | ( | void |  | ) | const

Indicates if this technique is supported by the current graphics card.

Remarks:
  This will only be correct after the Technique has been compiled, which is usually done from Material::compile.

bool Ogre::Technique::isTransparent | ( | void |  | ) | const

Returns true if this Technique involves transparency.

Remarks:
  This basically boils down to whether the first pass has a scene blending factor. Even if the other passes do not, the base colour, including parts of the original scene, may be used for blending, therefore we have to treat the whole Technique as transparent.

bool Ogre::Technique::isTransparentSortingEnabled | ( | void |  | ) | const

Returns true if this Technique has transparent sorting enabled.

Remarks:
  This basically boils down to whether the first pass has transparent sorting enabled or not

bool Ogre::Technique::isTransparentSortingForced | ( | void |  | ) | const

Returns true if this Technique has transparent sorting forced.

Remarks:
  This basically boils down to whether the first pass has transparent sorting forced or not

bool Ogre::Technique::movePass | ( | const unsigned short | sourceIndex,
|  | const unsigned short | destinationIndex |
| ) |  |  |

Move a pass from source index to destination index.

If successful then returns true.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

Technique& Ogre::Technique::operator= | ( | const Technique & | rhs | ) |

Overloaded operator to copy on Technique to another.

void Ogre::Technique::removeAllPasses | ( | void |  | ) |

Removes all Passes from this Technique.

void Ogre::Technique::removeGPUDeviceNameRule | ( | const String & | devicePattern | ) |

Removes a matching device name rule.

See also:
  addGPUDeviceNameRule

void Ogre::Technique::removeGPUVendorRule | ( | GPUVendor | vendor | ) |

Removes a matching vendor rule.

See also:
  addGPUVendorRule

void Ogre::Technique::removePass | ( | unsigned short | index | ) |

Removes the Pass with the given index.

void Ogre::Technique::setAmbient | ( | const ColourValue & | ambient | ) |

Sets the ambient colour reflectance properties for every Pass in every Technique.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setAmbient

void Ogre::Technique::setAmbient | ( | Real | red,
|  | Real | green,
|  | Real | blue |
| ) |  |  |

Sets the ambient colour reflectance properties for every Pass in every Technique.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setAmbient

void Ogre::Technique::setColourWriteEnabled | ( | bool | enabled | ) |

Sets whether or not colour buffer writing is enabled for each Pass.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setColourWriteEnabled

void Ogre::Technique::setCullingMode | ( | CullingMode | mode | ) |

Sets the culling mode for each pass based on the 'vertex winding'.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setCullingMode

void Ogre::Technique::setDepthBias | ( | float | constantBias,
|  | float | slopeScaleBias |
| ) |  |  |

Sets the depth bias to be used for each Pass.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setDepthBias

void Ogre::Technique::setDepthCheckEnabled | ( | bool | enabled | ) |

Sets whether or not each Pass renders with depth-buffer checking on or not.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setDepthCheckEnabled

void Ogre::Technique::setDepthFunction | ( | CompareFunction | func | ) |

Sets the function used to compare depth values when depth checking is on.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setDepthFunction

void Ogre::Technique::setDepthWriteEnabled | ( | bool | enabled | ) |

Sets whether or not each Pass renders with depth-buffer writing on or not.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setDepthWriteEnabled

void Ogre::Technique::setDiffuse | ( | Real | red,
|  | Real | green,
|  | Real | blue,
|  | Real | alpha |
| ) |  |  |

Sets the diffuse colour reflectance properties of every Pass in every Technique.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setDiffuse

void Ogre::Technique::setDiffuse | ( | const ColourValue & | diffuse | ) |

Sets the diffuse colour reflectance properties of every Pass in every Technique.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setDiffuse

void Ogre::Technique::setFog | ( | bool | overrideScene,
|  | FogMode | mode = `FOG_NONE`,
|  | const ColourValue & | colour = `ColourValue::White`,
|  | Real | expDensity = `0.001`,
|  | Real | linearStart = `0.0`,
|  | Real | linearEnd = `1.0` |
| ) |  |  |

Sets the fogging mode applied to each pass.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setFog

void Ogre::Technique::setLightingEnabled | ( | bool | enabled | ) |

Sets whether or not dynamic lighting is enabled for every Pass.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setLightingEnabled

void Ogre::Technique::setLodIndex | ( | unsigned short | index | ) |

Assigns a level-of-detail (LOD) index to this Technique.

Remarks:
  As noted previously, as well as providing fallback support for various graphics cards, multiple Technique objects can also be used to implement material LOD, where the detail of the material diminishes with distance to save rendering power.

  By default, all Techniques have a LOD index of 0, which means they are the highest level of detail. Increasing LOD indexes are lower levels of detail. You can assign more than one Technique to the same LOD index, meaning that the best Technique that is supported at that LOD index is used.

  You should not leave gaps in the LOD sequence; Ogre will allow you to do this and will continue to function as if the LODs were sequential, but it will confuse matters.

void Ogre::Technique::setManualCullingMode | ( | ManualCullingMode | mode | ) |

Sets the manual culling mode, performed by CPU rather than hardware.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setManualCullingMode

void Ogre::Technique::setName | ( | const String & | name | ) |

Set the name of the technique.

Remarks:
  The use of technique name is optional. Its useful in material scripts where a material could inherit from another material and only want to modify a particular technique.

void Ogre::Technique::setPointSize | ( | Real | ps | ) |

Sets the point size properties for every Pass in this Technique.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setPointSize

void Ogre::Technique::setSceneBlending | ( | const SceneBlendFactor | sourceFactor,
|  | const SceneBlendFactor | destFactor |
| ) |  |  |

Allows very fine control of blending every Pass with the existing contents of the scene.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setSceneBlending

void Ogre::Technique::setSceneBlending | ( | const SceneBlendType | sbt | ) |

Sets the kind of blending every pass has with the existing contents of the scene.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setSceneBlending

void Ogre::Technique::setSchemeName | ( | const String & | schemeName | ) |

Set the 'scheme name' for this technique.

Remarks:
  Material schemes are used to control top-level switching from one set of techniques to another. For example, you might use this to define 'high', 'medium' and 'low' complexity levels on materials to allow a user to pick a performance / quality ratio. Another possibility is that you have a fully HDR-enabled pipeline for top machines, rendering all objects using unclamped shaders, and a simpler pipeline for others; this can be implemented using schemes.

  Every technique belongs to a scheme - if you don't specify one, the Technique belongs to the scheme called 'Default', which is also the scheme used to render by default. The active scheme is set one of two ways - either by calling Viewport::setMaterialScheme, or by manually calling MaterialManager::setActiveScheme.

void Ogre::Technique::setSelfIllumination | ( | Real | red,
|  | Real | green,
|  | Real | blue |
| ) |  |  |

Sets the amount of self-illumination of every Pass in every Technique.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setSelfIllumination

void Ogre::Technique::setSelfIllumination | ( | const ColourValue & | selfIllum | ) |

Sets the amount of self-illumination of every Pass in every Technique.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setSelfIllumination

void Ogre::Technique::setSeparateSceneBlending | ( | const SceneBlendType | sbt,
|  | const SceneBlendType | sbta |
| ) |  |  |

Sets the kind of blending every pass has with the existing contents of the scene, using individual factors both color and alpha channels.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setSeparateSceneBlending

void Ogre::Technique::setSeparateSceneBlending | ( | const SceneBlendFactor | sourceFactor,
|  | const SceneBlendFactor | destFactor,
|  | const SceneBlendFactor | sourceFactorAlpha,
|  | const SceneBlendFactor | destFactorAlpha |
| ) |  |  |

Allows very fine control of blending every Pass with the existing contents of the scene, using individual factors both color and alpha channels.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setSeparateSceneBlending

void Ogre::Technique::setShadingMode | ( | ShadeOptions | mode | ) |

Sets the type of light shading required.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setShadingMode

void Ogre::Technique::setShadowCasterMaterial | ( | const Ogre::String & | name | ) |

set this material specific shadow casting specific material

void Ogre::Technique::setShadowCasterMaterial | ( | Ogre::MaterialPtr | val | ) |

set this material specific shadow casting specific material

void Ogre::Technique::setShadowReceiverMaterial | ( | Ogre::MaterialPtr | val | ) |

set this material specific shadow receiving specific material

void Ogre::Technique::setShadowReceiverMaterial | ( | const Ogre::String & | name | ) |

set this material specific shadow receiving specific material

void Ogre::Technique::setShininess | ( | Real | val | ) |

Sets the shininess properties of every Pass in every Technique.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setShininess

void Ogre::Technique::setSpecular | ( | const ColourValue & | specular | ) |

Sets the specular colour reflectance properties of every Pass in every Technique.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setSpecular

void Ogre::Technique::setSpecular | ( | Real | red,
|  | Real | green,
|  | Real | blue,
|  | Real | alpha |
| ) |  |  |

Sets the specular colour reflectance properties of every Pass in every Technique.

Note:
  This property actually exists on the Pass class. For simplicity, this method allows you to set these properties for every current Pass within this Technique. If you need more precision, retrieve the Pass instance and set the property there.

See also:
  Pass::setSpecular

void Ogre::Technique::setTextureAnisotropy | ( | unsigned int | maxAniso | ) |

Sets the anisotropy level to be used for all textures.

Note:
  This property has been moved to the TextureUnitState class, which is accessible via the Technique and Pass. For simplicity, this method allows you to set these properties for every current TeextureUnitState, If you need more precision, retrieve the Technique, Pass and TextureUnitState instances and set the property there.

See also:
  TextureUnitState::setTextureAnisotropy

void Ogre::Technique::setTextureFiltering | ( | TextureFilterOptions | filterType | ) |

Set texture filtering for every texture unit in every Pass.

Note:
  This property actually exists on the TextureUnitState class For simplicity, this method allows you to set these properties for every current TeextureUnitState, If you need more precision, retrieve the Pass and TextureUnitState instances and set the property there.

See also:
  TextureUnitState::setTextureFiltering

## Member Data Documentation

GPUDeviceNameRuleList Ogre::Technique::mGPUDeviceNameRules`[protected]`

Definition at line 146 of file OgreTechnique.h.

GPUVendorRuleList Ogre::Technique::mGPUVendorRules`[protected]`

Definition at line 145 of file OgreTechnique.h.

IlluminationPassList Ogre::Technique::mIlluminationPasses`[protected]`

List of derived passes, categorised into IlluminationStage (ordered).

Definition at line 68 of file OgreTechnique.h.

IlluminationPassesState Ogre::Technique::mIlluminationPassesCompilationPhase`[protected]`

Definition at line 71 of file OgreTechnique.h.

bool Ogre::Technique::mIsSupported`[protected]`

Definition at line 70 of file OgreTechnique.h.

unsigned short Ogre::Technique::mLodIndex`[protected]`

LOD level.

Definition at line 73 of file OgreTechnique.h.

String Ogre::Technique::mName`[protected]`

Definition at line 78 of file OgreTechnique.h.

Material* Ogre::Technique::mParent`[protected]`

Definition at line 69 of file OgreTechnique.h.

Passes Ogre::Technique::mPasses`[protected]`

List of primary passes.

Definition at line 66 of file OgreTechnique.h.

unsigned short Ogre::Technique::mSchemeIndex`[protected]`

Scheme index, derived from scheme name but the names are held on MaterialManager, for speed an index is used here.

Definition at line 77 of file OgreTechnique.h.

MaterialPtr Ogre::Technique::mShadowCasterMaterial`[protected]`

When casting shadow, if not using default Ogre shadow casting material, or nor using fixed function casting, mShadowCasterMaterial let you customize per material shadow caster behavior.

Definition at line 90 of file OgreTechnique.h.

String Ogre::Technique::mShadowCasterMaterialName`[protected]`

When casting shadow, if not using default Ogre shadow casting material, or nor using fixed function casting, mShadowCasterMaterial let you customize per material shadow caster behavior.There only material name is stored so that it can be loaded once all file parsed in a resource group.

Definition at line 95 of file OgreTechnique.h.

MaterialPtr Ogre::Technique::mShadowReceiverMaterial`[protected]`

When receiving shadow, if not using default Ogre shadow receiving material, or nor using fixed function texture projection receiving, mShadowReceiverMaterial let you customize per material shadow caster behavior.

Definition at line 100 of file OgreTechnique.h.

String Ogre::Technique::mShadowReceiverMaterialName`[protected]`

When receiving shadow, if not using default Ogre shadow receiving material, or nor using fixed function texture projection receiving, mShadowReceiverMaterial let you customize per material shadow caster behavior.

There only material name is stored so that it can be loaded once all file parsed in a resource group.

Definition at line 105 of file OgreTechnique.h.

UserObjectBindings Ogre::Technique::mUserObjectBindings`[protected]`

Definition at line 108 of file OgreTechnique.h.

The documentation for this class was generated from the following file:

- OgreTechnique.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:25:02